// MAMELISTJP_TO_CATSHANTY.cpp : DLL AvP[VpɃGNX|[g֐`܂B
//

#include "stdafx.h"
#include "mamelistjp_to_CatShanty.h"

//G[l̒`
const int ListFileNotFound	= 0x100;	//256	Xgt@CJȂ
const int CRCNotFound		= 0x200;	//512	Xgt@CɎw肳ꂽCRCl
const int ListNA			= 0x201;	//513	płȂXgۂ
const int ValAbsence		= 0x300;	//768	擾Yf[^͕s݂
const int ValNoNumeric		= 0x301;	//769	擾lł͂Ȃi߂ll̗̂pj

/********************************************************
g~O
http://www.cplusplus.com/faq/sequences/strings/trim/
********************************************************/
inline std::string trim_right_copy( const std::string& s, const std::string& delimiters = " \f\n\r\t\v" ){
  return s.substr( 0, s.find_last_not_of( delimiters ) + 1 );
}
inline std::string trim_left_copy( const std::string& s, const std::string& delimiters = " \f\n\r\t\v" ){
  return s.substr( s.find_first_not_of( delimiters ) );
}
inline std::string trim_copy( const std::string& s, const std::string& delimiters = " \f\n\r\t\v" ){
  return trim_left_copy( trim_right_copy( s, delimiters ), delimiters );
}

/*********************************************************

ݒt@C mamelistjp_to_CatShanty.cfg ̓ǂݍ

	ݒliesj𕶎̃xN^zŕԂB
	t@CJȂꍇ̓ftHgݒlԂB

*********************************************************/
std::vector<std::string> readRegExConf()
{
	using namespace std;
	string buf;

	//t@C̃pX쐬
	vector<TCHAR> vec( MAX_PATH+1, 0);
	GetCurrentDirectory( MAX_PATH, &vec[0] );
	string fn;
	for( int i=0; i<MAX_PATH; i++ ) fn += (LPCSTR)&vec[i];
	fn += "\\mamelistjp_to_CatShanty.cfg";
	vector<TCHAR>().swap(vec);

	//t@Cǂݍ
	locale::global( locale( "japanese" ) );
	ifstream hFile( fn );
	vector<string> excfg;
	if( !hFile.is_open() ){
		//t@CJȂȂftHg`
		excfg.push_back( "\\(.+?\\)" );	//K\
		excfg.push_back( "10" );		//}b`Ɏ擾ʒui擪 0jiɖȂ΍Ō̃}b`擾j
		excfg.push_back( "0" );			//^Cgo[W
	}else{
		//t@C`
		while( std::getline( hFile, buf ) ){
			excfg.push_back( buf.c_str() );
			if( excfg.size() >= 3 ) break;	//3sڂ܂œǂ߂OK
		}
		hFile.close();
	}
	return excfg;
}

/*************************************************************

^Cg琳K\ɂăo[WEi[

	ttl			^Cg
	pBuf		i[̃|C^
	iSize		i[obt@̃TCY
				0 ͕KvȃTCYԂis܂ށj

*************************************************************/
int GetVerFromTitle( std::string ttl, LPSTR &pBuf, int iSize )
{
	using namespace std;

	//ݒt@C琳K\擾
	vector<string> excfg = readRegExConf();

	//^Cg𐳋K\ŌE擾
	regex pat;
	smatch mat;
	regex_error paren( regex_constants::error_paren );
	try{
		pat = excfg[0].empty() ? "" : excfg[0];	//K\p^[Zbgisȃp^[ "*\(.+?\)" Ƃ͉̓G[ɂȂj
	}catch( ... ){
		return ValAbsence * -1;					//KȃG[R[hȂ̂ŁAŕԂ:P
	}

	//đS}b`xN^zɊi[
	vector<string> arrMat;
	int iGetpos = excfg[1].empty() ? atoi( 0 ) : atoi( excfg[1].c_str() );	//}b`̎擾ʒu𐔒lϊ
	if( iGetpos < 0 ) iGetpos = 0;
	while( regex_search( ttl, mat, pat, regex_constants::match_default ) ){
		arrMat.push_back( mat.str() );	//}b`zɊi[
		ttl = mat.suffix().str();		//}b`ȍ~ɋl߂
	}

	//wʒũ}b`擾
	string buf;
	if( !arrMat.empty() ){
		if( iGetpos < (int)arrMat.size() ){
			buf = arrMat[ iGetpos ];	//wʒu擾
		}else{
			buf = arrMat.back();		//wʒuɖȂ΍Ō̃}b`擾
		}
	}else{
		return ValAbsence * -1;			//}b`
	}

	//Xy[Xg
	buf = trim_copy( buf, " " );

	//߂lƊi[
	if( iSize == 0 ){
		return buf.length() + 1;
	} else {
		if( int(buf.length()+1) > iSize ) buf = buf.substr( 0, iSize-1 );	//wTCYȂJbg
		strcpy_s( pBuf, iSize, (LPSTR)buf.c_str() );
		return buf.length();
	}
}

/*************************************************************************************************************

mame_jp.lst f[^L[āAړI̕擾Ei[

	pData		Xgf[^̃|C^
	pKEY		L[̃|C^
	iKEYbit		L[̌`ԁi 0,32=32bitCRC / 1=16bitCRC / 100=FileName(body) / 101=FileName(body.ext) j
	pBuf		i[̃|C^
	iSize		i[obt@̃TCY
				0 ͕Kvȃobt@TCYԂis܂ށj
	itemPos		mame_jp.lst ɂāA擾񂪊YC̐擪牽ڂ̐^u(\t)̌ɂ邩

	* mame_jp.lst t@C͏O
	* mame_jp.lst 1C̉sR[hI[ \n O

*************************************************************************************************************/
int GetText( LPCTSTR &pData, LPCTSTR &pKEY, int iKEYbit, LPSTR &pBuf, int iSize, int itemPos )
{
	//mame_jp.lst  FileName(body) 
	if( iKEYbit != 100 ) return CRCNotFound * -1;

	//string^Ɏ荞񂶂ႤiyǑx́EE?j
	using namespace std;
	string dat  = (LPCSTR) pData;
	string key  = (LPCSTR) pKEY;
	string key2 = (LPCSTR) pKEY;
	string::size_type idx;
	string::size_type edx;

	//pɃL[`
	transform( key.begin(),  key.end(),  key.begin(),  tolower );
	transform( key2.begin(), key2.end(), key2.begin(), tolower );
	key  = "\n" + key  + "\t";	//2Cڈȍ~̌p
	key2 =        key2 + "\t";	//擪Čp

	//f[^L[
	idx = dat.find( key );
	if( idx != string::npos ){
		idx ++;								//F\t
	}else{
		idx = dat.find( key2 );				//sF擪CȂ
		if( idx != 0 ) idx = string::npos;
	}

	//ړI̕擾
	if( idx == string::npos ){
		return CRCNotFound * -1;			//sȂG[lԂ
	}else{
		//ACe擪
		for(int i=0; i<itemPos; i++){
			idx = dat.find( "\t", idx );
			if( idx == string::npos ) return ValAbsence * -1;
			idx ++;
		}
		//ACeI[
		switch( itemPos ){
			//[J[̏ꍇ͓
			case 3:
				edx = dat.find( "\r", idx );	//\r \n ̉sR[hŒTĂ݂
				if( edx == string::npos ){
					edx = dat.find( "\n", idx );
					if( edx == string::npos ){
						edx = dat.length();		//s΃f[^I[܂ł[J[
					}
				}
				break;
			//[J[ȊO
			default:
				edx = dat.find( "\t", idx );
				if( idx == string::npos ) return ValAbsence * -1;
				break;
		}
	}

	//߂lƊi[
	if( iSize == 0 ){
		return edx - idx + 1;	//Kvobt@Ԃ
	} else {
		int size = edx - idx;
		if( iSize < size + 1 ) size = iSize - 1;							//wTCYȂJbg
		strcpy_s( pBuf, iSize, (LPSTR)dat.substr( idx, size ).c_str() );	//i[
		return size;
	}
}






//////////////////////////////////////////////////////////////////////

// ȉGNX|[g֐ł

//////////////////////////////////////////////////////////////////////



//vOCo[WԂ
MAMELISTJP_TO_CATSHANTY_API int GetPluginVersion()
{
	return (int) (1.11 * 100);
}

//vOCҏi[
MAMELISTJP_TO_CATSHANTY_API int GetPluginAuthor( LPSTR &lpszAuthor, int iSize )
{
	std::string str = "hey_kitarou - www.catshanty.com";	//Jl̏ɕς邱
	if( iSize == 0 ){
		return str.length() + 1;					//TCYԂ
	} else {
		if( int(str.length()+1) > iSize ) str = str.substr( 0, iSize-1 );	//wobt@TCYȂJbg
		strcpy_s( lpszAuthor, iSize, str.c_str() );	//i[
		return str.length();
	}
}

//vOC̐i[
MAMELISTJP_TO_CATSHANTY_API int GetPluginInfo( LPSTR &lpszInfo, int iSize )
{
	std::string str = "mamelistjp̕ mame_jp.lst q؂܂B";
	if(iSize==0){
		return str.length() + 1;
	} else {
		if( int(str.length()+1) > iSize ) str = str.substr( 0, iSize-1 );
		strcpy_s( lpszInfo, iSize, str.c_str() );
		return str.length();
	}
}


//Jii[
MAMELISTJP_TO_CATSHANTY_API int GetKana( LPCTSTR pData, LPCTSTR pKEY, int iKEYbit, LPSTR &pBuf, int iSize )
{
	return GetText( pData, pKEY, iKEYbit, pBuf, iSize, 2 );
}

//[J[i[
MAMELISTJP_TO_CATSHANTY_API int GetMaker( LPCTSTR pData, LPCTSTR pKEY, int iKEYbit, LPSTR &pBuf, int iSize )
{
	return GetText( pData, pKEY, iKEYbit, pBuf, iSize, 3 );
}

//^Cgi[
MAMELISTJP_TO_CATSHANTY_API int GetTitle( LPCTSTR pData, LPCTSTR pKEY, int iKEYbit, LPSTR &pBuf, int iSize )
{
	//ݒt@C琳K\擾
	std::vector<std::string> excfg = readRegExConf();
	if( excfg[2] == "0" ){
		//^Cgo[WȂ
		return GetText( pData, pKEY, iKEYbit, pBuf, iSize, 1 );
	}else{
		//^Cgo[W

		//^Cg擾
		int res;
		res = GetText( pData, pKEY, iKEYbit, pBuf, 0, 1 );		//^Cg̕Kvobt@TCY擾
		if( res < 0 ) return res;

		LPSTR pTmp;
		pTmp = (LPSTR)calloc( res, sizeof(int) );
		res = GetText( pData, pKEY, iKEYbit, pTmp, res, 1 );	//^Cg擾
		std::string ttl = (LPSTR)pTmp;
		free( pTmp );

		//o[W擾
		res = GetVerFromTitle( ttl, pBuf, 0 );					//o[W̕Kvobt@TCY擾
		if( res > 1 ){
			pTmp = (LPSTR)calloc( res, sizeof(int) );
			res = GetVerFromTitle( ttl, pTmp, res );			//o[W擾
			std::string ver = (LPSTR)pTmp;
			free( pTmp );
			//^Cgo[W
			std::string::size_type pos( ttl.find( ver ) );
			ttl.replace( pos, ver.length(), "" );
			//Xy[Xg
			ttl = trim_copy( ttl, " " );
		}

		//߂lƊi[
		if( iSize == 0 ){
			return ttl.length() + 1;
		} else {
			if( int(ttl.length()+1) > iSize ) ttl = ttl.substr( 0, iSize-1 );
			strcpy_s( pBuf, iSize, (LPSTR)ttl.c_str() );
			return ttl.length();
		}
	}
}

//o[Wi[
int GetVersion( LPCTSTR pData, LPCTSTR pKEY, int iKEYbit, LPSTR &pBuf, int iSize )
{
	//o[W̓^Cg璊ôŁAx^Cg擾
	int res = GetText( pData, pKEY, iKEYbit, pBuf, 0, 1 );	//^Cg̕Kvobt@TCY擾
	if( res < 0 ) return res;

	LPSTR pTmp = (LPSTR)calloc( res, sizeof(int) );
	res = GetText( pData, pKEY, iKEYbit, pTmp, res, 1 );	//^Cg擾
	std::string ttl = (LPSTR)pTmp;
	free( pTmp );

	//^CgY擾Ei[
	if( res < 0 ){
		return res;
	}else{
		return GetVerFromTitle( ttl, pBuf, iSize );
	}
}
